﻿Enumeration
  #ca
EndEnumeration

Enumeration
  #menu_koi
  #menu_866
  #menu_1251
  #menu_hexdec
  #menu_about
EndEnumeration

Global enct.l=1
Global v$="ASCII table 1.0"
Global hexdec.l=0 ; 1 -hexadecimal code
Procedure drawchar()
  If StartDrawing(CanvasOutput(0))
    Box(0,0,256+8,256+8,$FFFFFF)
    For y=0 To 15
      For x=0 To 15
        For j=0 To 15
          a.l=PeekL(?koi8+enct*4096+j+x*16+y*256)
          b.l=128
          For i=0 To 7
            If a&b
              Box(8+x*16+i,y*16+j,1,1,0)
            EndIf
            b>>1
          Next i
        Next j
      Next x
    Next y
    ;cursor
    x = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseX)/16)*16
    y = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseY)/16)*16
    
    If x>=0 And y>=0 And x/16<16
      DrawingMode(#PB_2DDrawing_Outlined)
      Box(x+4,y,16,16,$0000FF)
      n$=Str(y+x/16)
      If hexdec
        n$=RSet(Hex(y+x/16),2,"0")
      EndIf
      SetWindowTitle(0,v$+",code:"+n$ )
    EndIf
    
    StopDrawing()
  EndIf
EndProcedure

Procedure setmenu()
  For i=0 To 2
    SetMenuItemState(0,#menu_koi+i,0)
  Next i
  SetMenuItemState(0,#menu_koi+enct,1)
EndProcedure


va=8
If OpenWindow(0, 0, 0, 256+va, 256, v$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(0, 0, 0, 256+va, 256)
  
  ;CopyMemory(?rest,?cp866,512)
  drawchar()
  If CreatePopupMenu(0)
    MenuItem(#menu_koi, "KOI8R")
    MenuItem(#menu_866, "CP866")
    MenuItem(#menu_1251, "Cp1251")
    MenuBar()
    MenuItem(#menu_hexdec, "Hex Code")
    MenuItem(#menu_about, "About")
  EndIf
  
  If OpenPreferences("asct.ini")
    PreferenceGroup("general")
    enct=ReadPreferenceLong("encoding",1)
    hexdec=ReadPreferenceLong("hexnum",1)
    SetMenuItemState(0,#menu_hexdec,hexdec)
    ClosePreferences() 
  EndIf
  
  setmenu()
  drawchar()
  
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf    
    Select event
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_koi:enct=0:setmenu():drawchar()
          Case #menu_866:enct=1:setmenu():drawchar()
          Case #menu_1251:enct=2:setmenu():drawchar()
          Case #menu_hexdec: hexdec=1-hexdec:SetMenuItemState(0,#menu_hexdec,hexdec)
          Case #menu_about: MessageRequester( v$,"by g0blinish")
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ca
            If EventType() = #PB_EventType_RightClick
              DisplayPopupMenu( 0,WindowID(0) )
            EndIf
            If EventType() = #PB_EventType_LeftClick
              x = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseX)/16)*16
              y = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseY)/16)*16
              If x>=0 And y>=0 And x/16<16
                n$=Chr(y+x/16)
                ;Debug n$
                SetClipboardText(n$)
              EndIf
              
            EndIf
            
            If EventType() = #PB_EventType_MouseMove
              drawchar()
            EndIf
        EndSelect
    EndSelect
  Until Event = #PB_Event_CloseWindow
  If CreatePreferences("asct.ini")
    PreferenceGroup("general")
    WritePreferenceLong("encoding",enct)
    WritePreferenceLong("hexnum",hexdec)
    ClosePreferences() 
  EndIf
EndIf

DataSection
  koi8:
  IncludeBinary "koi8-b.bin"
  cp866:
  IncludeBinary "vga8X16.FNT";"cp866.bin"
  cp1251:
  IncludeBinary "cp1251.bin"
  ;   rest:
  ;   IncludeBinary "866sys001_.fnt"
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 109
; FirstLine = 97
; Folding = -
; EnableXP
; UseIcon = asciit2.ico
; Executable = asciit.exe